package org.jboss.cache.lock;

import org.jboss.cache.Fqn;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.PessimisticUnversionedNode;
import org.jboss.cache.factories.context.PessimisticContextFactory;
import org.jboss.cache.invocation.InvocationContextContainer;
import org.jboss.cache.invocation.NodeInvocationDelegate;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

/**
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
@Test(groups = "unit")
public class NodeBasedLockManagerRecordingTest extends AbstractLockManagerRecordingTest
{
   @BeforeMethod
   public void setUp()
   {
      icc = new InvocationContextContainer();
      lm = new NodeBasedLockManager();
      PessimisticContextFactory pcf = new PessimisticContextFactory();
      icc.injectContextFactory(pcf);
      contextFactory = pcf;
      fqnBasedLocking = false;
   }

   @Override
   protected NodeSPI createNode(Fqn fqn)
   {
      PessimisticUnversionedNode un = new PessimisticUnversionedNode(fqn.getLastElement(), fqn, null, null);
      un.injectDependencies(null, null, null);
      un.injectLockStrategyFactory(new LockStrategyFactory());
      return new NodeInvocationDelegate(un);
   }
}
